diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class-oembed.php ./wordpress-3.3/wp-includes/class-oembed.php
*** ./wordpress-3.2.1/wp-includes/class-oembed.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class-oembed.php	2011-10-28 15:05:43.000000000 -0500
***************
*** 28,42 ****
  	function __construct() {
  		// List out some popular sites that support oEmbed.
  		// The WP_Embed class disables discovery for non-unfiltered_html users, so only providers in this array will be used for them.
! 		// Add to this list using the wp_oembed_add_provider() function (see it's PHPDoc for details).
  		$this->providers = apply_filters( 'oembed_providers', array(
  			'#http://(www\.)?youtube.com/watch.*#i'         => array( 'http://www.youtube.com/oembed',            true  ),
  			'http://youtu.be/*'                             => array( 'http://www.youtube.com/oembed',            false ),
  			'http://blip.tv/*'                              => array( 'http://blip.tv/oembed/',                   false ),
! 			'#http://(www\.)?vimeo\.com/.*#i'               => array( 'http://www.vimeo.com/api/oembed.{format}', true  ),
  			'#http://(www\.)?dailymotion\.com/.*#i'         => array( 'http://www.dailymotion.com/api/oembed',    true  ),
  			'#http://(www\.)?flickr\.com/.*#i'              => array( 'http://www.flickr.com/services/oembed/',   true  ),
! 			'#http://(.+)?smugmug\.com/.*#i'                => array( 'http://api.smugmug.com/services/oembed/',  true  ),
  			'#http://(www\.)?hulu\.com/watch/.*#i'          => array( 'http://www.hulu.com/api/oembed.{format}',  true  ),
  			'#http://(www\.)?viddler\.com/.*#i'             => array( 'http://lab.viddler.com/services/oembed/',  true  ),
  			'http://qik.com/*'                              => array( 'http://qik.com/api/oembed.{format}',       false ),
--- 28,42 ----
  	function __construct() {
  		// List out some popular sites that support oEmbed.
  		// The WP_Embed class disables discovery for non-unfiltered_html users, so only providers in this array will be used for them.
! 		// Add to this list using the wp_oembed_add_provider() function (see its PHPDoc for details).
  		$this->providers = apply_filters( 'oembed_providers', array(
  			'#http://(www\.)?youtube.com/watch.*#i'         => array( 'http://www.youtube.com/oembed',            true  ),
  			'http://youtu.be/*'                             => array( 'http://www.youtube.com/oembed',            false ),
  			'http://blip.tv/*'                              => array( 'http://blip.tv/oembed/',                   false ),
! 			'#http://(www\.)?vimeo\.com/.*#i'               => array( 'http://vimeo.com/api/oembed.{format}',     true  ),
  			'#http://(www\.)?dailymotion\.com/.*#i'         => array( 'http://www.dailymotion.com/api/oembed',    true  ),
  			'#http://(www\.)?flickr\.com/.*#i'              => array( 'http://www.flickr.com/services/oembed/',   true  ),
! 			'#http://(.+\.)?smugmug\.com/.*#i'              => array( 'http://api.smugmug.com/services/oembed/',  true  ),
  			'#http://(www\.)?hulu\.com/watch/.*#i'          => array( 'http://www.hulu.com/api/oembed.{format}',  true  ),
  			'#http://(www\.)?viddler\.com/.*#i'             => array( 'http://lab.viddler.com/services/oembed/',  true  ),
  			'http://qik.com/*'                              => array( 'http://qik.com/api/oembed.{format}',       false ),
***************
*** 45,51 ****
  			'http://gi*.photobucket.com/groups/*'           => array( 'http://photobucket.com/oembed',            false ),
  			'#http://(www\.)?scribd\.com/.*#i'              => array( 'http://www.scribd.com/services/oembed',    true  ),
  			'http://wordpress.tv/*'                         => array( 'http://wordpress.tv/oembed/',              false ),
! 			'#http://(answers|surveys)\.polldaddy.com/.*#i' => array( 'http://polldaddy.com/oembed/',             true  ),
  			'#http://(www\.)?funnyordie\.com/videos/.*#i'   => array( 'http://www.funnyordie.com/oembed',         true  ),
  		) );
  
--- 45,51 ----
  			'http://gi*.photobucket.com/groups/*'           => array( 'http://photobucket.com/oembed',            false ),
  			'#http://(www\.)?scribd\.com/.*#i'              => array( 'http://www.scribd.com/services/oembed',    true  ),
  			'http://wordpress.tv/*'                         => array( 'http://wordpress.tv/oembed/',              false ),
! 			'#http://(.+\.)?polldaddy\.com/.*#i'            => array( 'http://polldaddy.com/oembed/',             true  ),
  			'#http://(www\.)?funnyordie\.com/videos/.*#i'   => array( 'http://www.funnyordie.com/oembed',         true  ),
  		) );
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class-phpass.php ./wordpress-3.3/wp-includes/class-phpass.php
*** ./wordpress-3.2.1/wp-includes/class-phpass.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class-phpass.php	2011-09-03 11:02:41.000000000 -0500
***************
*** 49,55 ****
  
  		$this->portable_hashes = $portable_hashes;
  
! 		$this->random_state = microtime() . uniqid(rand(), TRUE); // removed getmypid() for compability reasons
  	}
  
  	function get_random_bytes($count)
--- 49,55 ----
  
  		$this->portable_hashes = $portable_hashes;
  
! 		$this->random_state = microtime() . uniqid(rand(), TRUE); // removed getmypid() for compatibility reasons
  	}
  
  	function get_random_bytes($count)
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class-wp-admin-bar.php ./wordpress-3.3/wp-includes/class-wp-admin-bar.php
*** ./wordpress-3.2.1/wp-includes/class-wp-admin-bar.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class-wp-admin-bar.php	2011-12-05 21:51:58.000000000 -0600
***************
*** 1,31 ****
  <?php
  class WP_Admin_Bar {
! 	var $changed_locale = false;
! 	var $menu;
! 	var $need_to_change_locale = false;
! 	var $proto = 'http://';
! 	var $user;
! 
! 	function initialize() {
! 		/* Set the protocol used throughout this code */
! 		if ( is_ssl() )
! 			$this->proto = 'https://';
  
  		$this->user = new stdClass;
- 		$this->menu = new stdClass;
  
! 		/* Populate settings we need for the menu based on the current user. */
! 		$this->user->blogs = get_blogs_of_user( get_current_user_id() );
! 		if ( is_multisite() ) {
! 			$this->user->active_blog = get_active_blog_for_user( get_current_user_id() );
! 			$this->user->domain = empty( $this->user->active_blog ) ? user_admin_url() : trailingslashit( get_home_url( $this->user->active_blog->blog_id ) );
! 			$this->user->account_domain = $this->user->domain;
! 		} else {
! 			$this->user->active_blog = $this->user->blogs[get_current_blog_id()];
! 			$this->user->domain = trailingslashit( home_url() );
! 			$this->user->account_domain = $this->user->domain;
  		}
- 		$this->user->locale = get_locale();
  
  		add_action( 'wp_head', 'wp_admin_bar_header' );
  
--- 1,37 ----
  <?php
  class WP_Admin_Bar {
! 	private $nodes = array();
! 	private $bound = false;
! 	public $user;
! 
! 	public function __get( $name ) {
! 		switch ( $name ) {
! 			case 'proto' :
! 				return is_ssl() ? 'https://' : 'http://';
! 				break;
! 			case 'menu' :
! 				_deprecated_argument( 'WP_Admin_Bar', '3.3', 'Modify admin bar nodes with WP_Admin_Bar::get_node(), WP_Admin_Bar::add_node(), and WP_Admin_Bar::remove_node(), not the <code>menu</code> property.' );
! 				return array(); // Sorry, folks.
! 				break;
! 		}
! 	}
  
+ 	public function initialize() {
  		$this->user = new stdClass;
  
! 		if ( is_user_logged_in() ) {
! 			/* Populate settings we need for the menu based on the current user. */
! 			$this->user->blogs = get_blogs_of_user( get_current_user_id() );
! 			if ( is_multisite() ) {
! 				$this->user->active_blog = get_active_blog_for_user( get_current_user_id() );
! 				$this->user->domain = empty( $this->user->active_blog ) ? user_admin_url() : trailingslashit( get_home_url( $this->user->active_blog->blog_id ) );
! 				$this->user->account_domain = $this->user->domain;
! 			} else {
! 				$this->user->active_blog = $this->user->blogs[get_current_blog_id()];
! 				$this->user->domain = trailingslashit( home_url() );
! 				$this->user->account_domain = $this->user->domain;
! 			}
  		}
  
  		add_action( 'wp_head', 'wp_admin_bar_header' );
  
***************
*** 47,237 ****
  		do_action( 'admin_bar_init' );
  	}
  
! 	function add_menu( $args = array() ) {
  		$defaults = array(
! 			'title' => false,
! 			'href' => false,
! 			'parent' => false, // false for a root menu, pass the ID value for a submenu of that menu.
! 			'id' => false, // defaults to a sanitized title value.
! 			'meta' => false // array of any of the following options: array( 'html' => '', 'class' => '', 'onclick' => '', target => '', title => '' );
  		);
  
! 		$r = wp_parse_args( $args, $defaults );
! 		extract( $r, EXTR_SKIP );
  
! 		if ( empty( $title ) )
! 			return false;
  
- 		/* Make sure we have a valid ID */
  		if ( empty( $id ) )
! 			$id = esc_attr( sanitize_title( trim( $title ) ) );
  
! 		if ( ! empty( $parent ) ) {
! 			/* Add the menu to the parent item */
! 			$child = array( 'id' => $id, 'title' => $title, 'href' => $href );
  
! 			if ( ! empty( $meta ) )
! 				$child['meta'] = $meta;
  
! 			$this->add_node( $parent, $this->menu, $child );
! 		} else {
! 			/* Add the menu item */
! 			$this->menu->{$id} = array( 'title' => $title, 'href' => $href );
  
! 			if ( ! empty( $meta ) )
! 				$this->menu->{$id}['meta'] = $meta;
! 		}
  	}
  
! 	function remove_menu( $id ) {
! 		return $this->remove_node( $id, $this->menu );
  	}
  
! 	function render() {
  		?>
! 		<div id="wpadminbar">
  			<div class="quicklinks">
! 				<ul>
! 					<?php foreach ( (array) $this->menu as $id => $menu_item ) : ?>
! 						<?php $this->recursive_render( $id, $menu_item ) ?>
! 					<?php endforeach; ?>
! 				</ul>
! 			</div>
! 
! 			<div id="adminbarsearch-wrap">
! 				<form action="<?php echo home_url(); ?>" method="get" id="adminbarsearch">
! 					<input class="adminbar-input" name="s" id="adminbar-search" type="text" value="" maxlength="150" />
! 					<input type="submit" class="adminbar-button" value="<?php _e('Search'); ?>"/>
! 				</form>
  			</div>
  		</div>
  
  		<?php
- 		/* Wipe the menu, might reduce memory usage, but probably not. */
- 		$this->menu = null;
  	}
  
! 	/* Helpers */
! 	function recursive_render( $id, &$menu_item ) { ?>
! 		<?php
! 		$is_parent =  ! empty( $menu_item['children'] );
  
- 		$menuclass = $is_parent ? 'menupop' : '';
- 		if ( ! empty( $menu_item['meta']['class'] ) )
- 			$menuclass .= ' ' . $menu_item['meta']['class'];
  		?>
  
! 		<li id="<?php echo esc_attr( "wp-admin-bar-$id" ); ?>" class="<?php echo esc_attr( $menuclass ); ?>">
! 			<a href="<?php echo esc_url( $menu_item['href'] ) ?>"<?php
! 				if ( ! empty( $menu_item['meta']['onclick'] ) ) :
! 					?> onclick="<?php echo esc_js( $menu_item['meta']['onclick'] ); ?>"<?php
  				endif;
! 			if ( ! empty( $menu_item['meta']['target'] ) ) :
! 				?> target="<?php echo esc_attr( $menu_item['meta']['target'] ); ?>"<?php
! 			endif;
! 			if ( ! empty( $menu_item['meta']['title'] ) ) :
! 				?> title="<?php echo esc_attr( $menu_item['meta']['title'] ); ?>"<?php
  			endif;
  
! 			?>><?php
  
! 			if ( $is_parent ) :
! 				?><span><?php
  			endif;
  
- 			echo $menu_item['title'];
- 
  			if ( $is_parent ) :
! 				?></span><?php
  			endif;
  
! 			?></a>
  
! 			<?php if ( $is_parent ) : ?>
! 			<ul>
! 				<?php foreach ( $menu_item['children'] as $child_id => $child_menu_item ) : ?>
! 					<?php $this->recursive_render( $child_id, $child_menu_item ); ?>
! 				<?php endforeach; ?>
! 			</ul>
! 			<?php endif; ?>
! 
! 			<?php if ( ! empty( $menu_item['meta']['html'] ) ) : ?>
! 				<?php echo $menu_item['meta']['html']; ?>
! 			<?php endif; ?>
  		</li><?php
  	}
  
! 	function add_node( $parent_id, &$menu, $child ) {
! 		foreach( $menu as $id => $menu_item ) {
! 			if ( $parent_id == $id ) {
! 				$menu->{$parent_id}['children']->{$child['id']} = $child;
! 				$child = null;
! 				return true;
! 			}
! 
! 			if ( ! empty( $menu->{$id}['children'] ) )
! 				$this->add_node( $parent_id, $menu->{$id}['children'], $child );
! 		}
! 
! 		$child = null;
! 
! 		return false;
  	}
  
! 	function add_menus() {
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_my_account_menu', 10 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_my_sites_menu', 20 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_dashboard_view_site_menu', 25 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_edit_menu', 30 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_shortlink_menu', 80 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_updates_menu', 70 );
! 
! 		if ( !is_network_admin() && !is_user_admin() ) {
! 			add_action( 'admin_bar_menu', 'wp_admin_bar_new_content_menu', 40 );
! 			add_action( 'admin_bar_menu', 'wp_admin_bar_comments_menu', 50 );
! 			add_action( 'admin_bar_menu', 'wp_admin_bar_appearance_menu', 60 );
! 		}
! 
! 		do_action( 'add_admin_bar_menus' );
! 	}
  
! 	function remove_node( $id, &$menu ) {
! 		if ( isset( $menu->$id ) ) {
! 			unset( $menu->$id );
! 			return true;
! 		}
  
! 		foreach( $menu as $menu_item_id => $menu_item ) {
! 			if ( ! empty( $menu->{$menu_item_id}['children'] ) )
! 				$this->remove_node( $id, $menu->{$menu_item_id}['children'] );
  		}
  
! 		return false;
! 	}
! 
! 	// TODO: Convert to a core feature for multisite or remove
! 	function load_user_locale_translations() {
! 		$this->need_to_change_locale = ( get_locale() != $this->user->locale );
! 		if ( ! $this->need_to_change_locale )
! 			return;
! 		/*
! 		$this->previous_translations = get_translations_for_domain( 'default' );
! 		$this->adminbar_locale_filter = lambda( '$_', '$GLOBALS["wp_admin_bar"]->user->locale;' );
! 		unload_textdomain( 'default' );
! 		add_filter( 'locale', $this->adminbar_locale_filter );
! 		load_default_textdomain();
! 		$this->changed_locale = true;
! 		*/
! 	}
  
! 	function unload_user_locale_translations() {
! 		global $l10n;
! 		if ( ! $this->changed_locale )
! 			return;
! 		/*
! 		remove_filter( 'locale', $this->adminbar_locale_filter );
! 		$l10n['default'] = &$this->previous_translations;
! 		*/
  	}
  }
  ?>
--- 53,473 ----
  		do_action( 'admin_bar_init' );
  	}
  
! 	public function add_menu( $node ) {
! 		$this->add_node( $node );
! 	}
! 
! 	public function remove_menu( $id ) {
! 		$this->remove_node( $id );
! 	}
! 
! 	/**
! 	 * Add a node to the menu.
! 	 *
! 	 * @param array $args - The arguments for each node.
! 	 * - id         - string    - The ID of the item.
! 	 * - title      - string    - The title of the node.
! 	 * - parent     - string    - The ID of the parent node. Optional.
! 	 * - href       - string    - The link for the item. Optional.
! 	 * - group      - boolean   - If the node is a group. Optional. Default false.
! 	 * - meta       - array     - Meta data including the following keys: html, class, onclick, target, title, tabindex.
! 	 */
! 	public function add_node( $args ) {
! 		// Shim for old method signature: add_node( $parent_id, $menu_obj, $args )
! 		if ( func_num_args() >= 3 && is_string( func_get_arg(0) ) )
! 			$args = array_merge( array( 'parent' => func_get_arg(0) ), func_get_arg(2) );
! 
! 		if ( is_object( $args ) )
! 			$args = get_object_vars( $args );
! 
! 		// Ensure we have a valid title.
! 		if ( empty( $args['id'] ) ) {
! 			if ( empty( $args['title'] ) )
! 				return;
! 
! 			_doing_it_wrong( __METHOD__, __( 'The menu ID should not be empty.' ), '3.3' );
! 			// Deprecated: Generate an ID from the title.
! 			$args['id'] = esc_attr( sanitize_title( trim( $args['title'] ) ) );
! 		}
! 
  		$defaults = array(
! 			'id'     => false,
! 			'title'  => false,
! 			'parent' => false,
! 			'href'   => false,
! 			'group'  => false,
! 			'meta'   => array(),
  		);
  
! 		// If the node already exists, keep any data that isn't provided.
! 		if ( $maybe_defaults = $this->get_node( $args['id'] ) )
! 			$defaults = get_object_vars( $maybe_defaults );
! 
! 		// Do the same for 'meta' items.
! 		if ( ! empty( $defaults['meta'] ) && empty( $args['meta'] ) )
! 			$args['meta'] = wp_parse_args( $args['meta'], $defaults['meta'] );
! 
! 		$args = wp_parse_args( $args, $defaults );
! 
! 		$back_compat_parents = array(
! 			'my-account-with-avatar' => array( 'my-account', '3.3' ),
! 			'my-blogs'               => array( 'my-sites',   '3.3' ),
! 		);
! 
! 		if ( isset( $back_compat_parents[ $args['parent'] ] ) ) {
! 			list( $new_parent, $version ) = $back_compat_parents[ $args['parent'] ];
! 			_deprecated_argument( __METHOD__, $version, sprintf( 'Use <code>%s</code> as the parent for the <code>%s</code> admin bar node instead of <code>%s</code>.', $new_parent, $args['id'], $args['parent'] ) );
! 			$args['parent'] = $new_parent;
! 		}
! 
! 		$this->_set_node( $args );
! 	}
! 
! 	final protected function _set_node( $args ) {
! 		$this->nodes[ $args['id'] ] = (object) $args;
! 	}
! 
! 	/**
! 	 * Gets a node.
! 	 *
! 	 * @return object Node.
! 	 */
! 	final public function get_node( $id ) {
! 		if ( $node = $this->_get_node( $id ) )
! 			return clone $node;
! 	}
  
! 	final protected function _get_node( $id ) {
! 		if ( $this->bound )
! 			return;
  
  		if ( empty( $id ) )
! 			$id = 'root';
  
! 		if ( isset( $this->nodes[ $id ] ) )
! 			return $this->nodes[ $id ];
! 	}
  
! 	final public function get_nodes() {
! 	   if ( ! $nodes = $this->_get_nodes() )
! 	      return;
! 
! 	   foreach ( $nodes as &$node ) {
! 	       $node = clone $node;
! 	   }
! 	   return $nodes;
! 	}
  
! 	final protected function _get_nodes() {
! 		if ( $this->bound )
! 			return;
  
! 		return $this->nodes;
! 	}
! 
! 	/**
! 	 * Add a group to a menu node.
! 	 *
! 	 * @since 3.3.0
! 	 *
! 	 * @param array $args - The arguments for each node.
! 	 * - id         - string    - The ID of the item.
! 	 * - parent     - string    - The ID of the parent node. Optional. Default root.
! 	 * - meta       - array     - Meta data including the following keys: class, onclick, target, title.
! 	 */
! 	final public function add_group( $args ) {
! 		$args['group'] = true;
! 
! 		$this->add_node( $args );
! 	}
! 
! 	/**
! 	 * Remove a node.
! 	 *
! 	 * @return object The removed node.
! 	 */
! 	public function remove_node( $id ) {
! 		$this->_unset_node( $id );
! 	}
! 
! 	final protected function _unset_node( $id ) {
! 		unset( $this->nodes[ $id ] );
  	}
  
! 	public function render() {
! 		$root = $this->_bind();
! 		$this->_render( $root );
! 	}
! 
! 	final protected function _bind() {
! 		if ( $this->bound )
! 			return;
! 
! 		// Add the root node.
! 		// Clear it first, just in case. Don't mess with The Root.
! 		$this->remove_node( 'root' );
! 		$this->add_node( array(
! 			'id'    => 'root',
! 			'group' => false,
! 		) );
! 
! 		// Normalize nodes: define internal 'children' and 'type' properties.
! 		foreach ( $this->_get_nodes() as $node ) {
! 			$node->children = array();
! 			$node->type = ( $node->group ) ? 'group' : 'item';
! 			unset( $node->group );
! 
! 			// The Root wants your orphans. No lonely items allowed.
! 			if ( ! $node->parent )
! 				$node->parent = 'root';
! 		}
! 
! 		foreach ( $this->_get_nodes() as $node ) {
! 			if ( 'root' == $node->id )
! 				continue;
! 
! 			// Fetch the parent node. If it isn't registered, ignore the node.
! 			if ( ! $parent = $this->_get_node( $node->parent ) ) {
! 				continue;
! 			}
! 
! 			// Generate the group class (we distinguish between top level and other level groups).
! 			$group_class = ( $node->parent == 'root' ) ? 'ab-top-menu' : 'ab-submenu';
! 
! 			if ( $node->type == 'group' ) {
! 				if ( empty( $node->meta['class'] ) )
! 					$node->meta['class'] = '';
! 				$node->meta['class'] .= ' ' . $group_class;
! 			}
! 
! 			// Items in items aren't allowed. Wrap nested items in 'default' groups.
! 			if ( $parent->type == 'item' && $node->type == 'item' ) {
! 				$default_id = $parent->id . '-default';
! 				$default    = $this->_get_node( $default_id );
! 
! 				// The default group is added here to allow groups that are
! 				// added before standard menu items to render first.
! 				if ( ! $default ) {
! 					// Use _set_node because add_node can be overloaded.
! 					// Make sure to specify default settings for all properties.
! 					$this->_set_node( array(
! 						'id'        => $default_id,
! 						'parent'    => $parent->id,
! 						'type'      => 'group',
! 						'children'  => array(),
! 						'meta'      => array(
! 							'class'     => $group_class,
! 						),
! 						'title'     => false,
! 						'href'      => false,
! 					) );
! 					$default = $this->_get_node( $default_id );
! 					$parent->children[] = $default;
! 				}
! 				$parent = $default;
! 
! 			// Groups in groups aren't allowed. Add a special 'container' node.
! 			// The container will invisibly wrap both groups.
! 			} elseif ( $parent->type == 'group' && $node->type == 'group' ) {
! 				$container_id = $parent->id . '-container';
! 				$container    = $this->_get_node( $container_id );
! 
! 				// We need to create a container for this group, life is sad.
! 				if ( ! $container ) {
! 					// Use _set_node because add_node can be overloaded.
! 					// Make sure to specify default settings for all properties.
! 					$this->_set_node( array(
! 						'id'       => $container_id,
! 						'type'     => 'container',
! 						'children' => array( $parent ),
! 						'parent'   => false,
! 						'title'    => false,
! 						'href'     => false,
! 						'meta'     => array(),
! 					) );
! 
! 					$container = $this->_get_node( $container_id );
! 
! 					// Link the container node if a grandparent node exists.
! 					$grandparent = $this->_get_node( $parent->parent );
! 
! 					if ( $grandparent ) {
! 						$container->parent = $grandparent->id;
! 
! 						$index = array_search( $parent, $grandparent->children, true );
! 						if ( $index === false )
! 							$grandparent->children[] = $container;
! 						else
! 							array_splice( $grandparent->children, $index, 1, array( $container ) );
! 					}
! 
! 					$parent->parent = $container->id;
! 				}
! 
! 				$parent = $container;
! 			}
! 
! 			// Update the parent ID (it might have changed).
! 			$node->parent = $parent->id;
! 
! 			// Add the node to the tree.
! 			$parent->children[] = $node;
! 		}
! 
! 		$root = $this->_get_node( 'root' );
! 		$this->bound = true;
! 		return $root;
  	}
  
! 	final protected function _render( $root ) {
! 		global $is_IE, $is_iphone;
! 
! 		// Add browser classes.
! 		// We have to do this here since admin bar shows on the front end.
! 		$class = 'nojq nojs';
! 		if ( $is_IE ) {
! 			if ( strpos( $_SERVER['HTTP_USER_AGENT'], 'MSIE 7' ) )
! 				$class .= ' ie7';
! 			elseif ( strpos( $_SERVER['HTTP_USER_AGENT'], 'MSIE 8' ) )
! 				$class .= ' ie8';
! 			elseif ( strpos( $_SERVER['HTTP_USER_AGENT'], 'MSIE 9' ) )
! 				$class .= ' ie9';
! 		} elseif ( $is_iphone ) {
! 			$class .= ' mobile';
! 		}
! 
  		?>
! 		<div id="wpadminbar" class="<?php echo $class; ?>" role="navigation">
  			<div class="quicklinks">
! 				<?php foreach ( $root->children as $group ) {
! 					$this->_render_group( $group );
! 				} ?>
  			</div>
  		</div>
  
  		<?php
  	}
  
! 	final protected function _render_container( $node ) {
! 		if ( $node->type != 'container' || empty( $node->children ) )
! 			return;
! 
! 		?><div id="<?php echo esc_attr( 'wp-admin-bar-' . $node->id ); ?>" class="ab-group-container"><?php
! 			foreach ( $node->children as $group ) {
! 				$this->_render_group( $group );
! 			}
! 		?></div><?php
! 	}
! 
! 	final protected function _render_group( $node ) {
! 		if ( $node->type == 'container' )
! 			return $this->_render_container( $node );
! 
! 		if ( $node->type != 'group' || empty( $node->children ) )
! 			return;
! 
! 		$class = empty( $node->meta['class'] ) ? '' : $node->meta['class'];
! 
! 		?><ul id="<?php echo esc_attr( 'wp-admin-bar-' . $node->id ); ?>" class="<?php echo esc_attr( $class ); ?>"><?php
! 			foreach ( $node->children as $item ) {
! 				$this->_render_item( $item );
! 			}
! 		?></ul><?php
! 	}
! 
! 	final protected function _render_item( $node ) {
! 		if ( $node->type != 'item' )
! 			return;
! 
! 		$is_parent = ! empty( $node->children );
! 		$has_link  = ! empty( $node->href );
! 
! 		$tabindex = isset( $node->meta['tabindex'] ) ? (int) $node->meta['tabindex'] : 10;
! 
! 		$menuclass = '';
! 		$aria_attributes = 'tabindex="' . $tabindex . '"';
! 
! 		if ( $is_parent ) {
! 			$menuclass = 'menupop';
! 			$aria_attributes .= ' aria-haspopup="true"';
! 		}
! 
! 		if ( ! empty( $node->meta['class'] ) )
! 			$menuclass .= ' ' . $node->meta['class'];
  
  		?>
  
! 		<li id="<?php echo esc_attr( 'wp-admin-bar-' . $node->id ); ?>" class="<?php echo esc_attr( $menuclass ); ?>"><?php
! 			if ( $has_link ):
! 				?><a class="ab-item" <?php echo $aria_attributes; ?> href="<?php echo esc_url( $node->href ) ?>"<?php
! 					if ( ! empty( $node->meta['onclick'] ) ) :
! 						?> onclick="<?php echo esc_js( $node->meta['onclick'] ); ?>"<?php
! 					endif;
! 				if ( ! empty( $node->meta['target'] ) ) :
! 					?> target="<?php echo esc_attr( $node->meta['target'] ); ?>"<?php
  				endif;
! 				if ( ! empty( $node->meta['title'] ) ) :
! 					?> title="<?php echo esc_attr( $node->meta['title'] ); ?>"<?php
! 				endif;
! 				?>><?php
! 			else:
! 				?><div class="ab-item ab-empty-item" <?php echo $aria_attributes;
! 				if ( ! empty( $node->meta['title'] ) ) :
! 					?> title="<?php echo esc_attr( $node->meta['title'] ); ?>"<?php
! 				endif;
! 				?>><?php
  			endif;
  
! 			echo $node->title;
  
! 			if ( $has_link ) :
! 				?></a><?php
! 			else:
! 				?></div><?php
  			endif;
  
  			if ( $is_parent ) :
! 				?><div class="ab-sub-wrapper"><?php
! 					foreach ( $node->children as $group ) {
! 						$this->_render_group( $group );
! 					}
! 				?></div><?php
  			endif;
  
! 			if ( ! empty( $node->meta['html'] ) )
! 				echo $node->meta['html'];
  
! 			?>
  		</li><?php
  	}
  
! 	public function recursive_render( $id, $node ) {
! 		_deprecated_function( __METHOD__, '3.3', 'WP_Admin_bar::render(), WP_Admin_Bar::_render_item()' );
! 		$this->_render_item( $node );
  	}
  
! 	public function add_menus() {
! 		// User related, aligned right.
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_my_account_menu', 0 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_search_menu', 4 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_my_account_item', 7 );
  
! 		// Site related.
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_wp_menu', 10 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_my_sites_menu', 20 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_site_menu', 30 );
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_updates_menu', 40 );
  
! 		// Content related.
! 		if ( ! is_network_admin() && ! is_user_admin() ) {
! 			add_action( 'admin_bar_menu', 'wp_admin_bar_comments_menu', 60 );
! 			add_action( 'admin_bar_menu', 'wp_admin_bar_new_content_menu', 70 );
  		}
+ 		add_action( 'admin_bar_menu', 'wp_admin_bar_edit_menu', 80 );
  
! 		add_action( 'admin_bar_menu', 'wp_admin_bar_add_secondary_groups', 200 );
  
! 		do_action( 'add_admin_bar_menus' );
  	}
  }
  ?>
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class.wp-dependencies.php ./wordpress-3.3/wp-includes/class.wp-dependencies.php
*** ./wordpress-3.2.1/wp-includes/class.wp-dependencies.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class.wp-dependencies.php	2011-07-28 13:24:00.000000000 -0500
***************
*** 39,45 ****
  		$this->all_deps( $handles );
  
  		foreach( $this->to_do as $key => $handle ) {
! 			if ( !in_array($handle, $this->done) && isset($this->registered[$handle]) ) {
  
  				if ( ! $this->registered[$handle]->src ) { // Defines a group.
  					$this->done[] = $handle;
--- 39,45 ----
  		$this->all_deps( $handles );
  
  		foreach( $this->to_do as $key => $handle ) {
! 			if ( !in_array($handle, $this->done, true) && isset($this->registered[$handle]) ) {
  
  				if ( ! $this->registered[$handle]->src ) { // Defines a group.
  					$this->done[] = $handle;
***************
*** 134,150 ****
  	/**
  	 * Adds extra data
  	 *
! 	 * Adds data only if script has already been added
  	 *
  	 * @param string $handle Script name
! 	 * @param string $data_name Name of object in which to store extra data
! 	 * @param array $data Array of extra data
  	 * @return bool success
  	 */
! 	function add_data( $handle, $data_name, $data ) {
! 		if ( !isset($this->registered[$handle]) )
  			return false;
! 		return $this->registered[$handle]->add_data( $data_name, $data );
  	}
  
  	function remove( $handles ) {
--- 134,172 ----
  	/**
  	 * Adds extra data
  	 *
! 	 * Adds data only if script has already been added.
  	 *
  	 * @param string $handle Script name
! 	 * @param string $key
! 	 * @param mixed $value
  	 * @return bool success
  	 */
! 	function add_data( $handle, $key, $value ) {
! 		if ( !isset( $this->registered[$handle] ) )
  			return false;
! 
! 		return $this->registered[$handle]->add_data( $key, $value );
! 	}
! 
! 	/**
! 	 * Get extra data
! 	 *
! 	 * Gets data associated with a certain handle.
! 	 *
! 	 * @since WP 3.3
! 	 *
! 	 * @param string $handle Script name
! 	 * @param string $key
! 	 * @return mixed
! 	 */
! 	function get_data( $handle, $key ) {
! 		if ( !isset( $this->registered[$handle] ) )
! 			return false;
! 
! 		if ( !isset( $this->registered[$handle]->extra[$key] ) )
! 			return false;
! 
! 		return $this->registered[$handle]->extra[$key];
  	}
  
  	function remove( $handles ) {
